<template>
  <div>
    <!-- Content -->
    <div v-if="resource">
      <!-- Individual Fields -->
      <div
        v-for="(resourceOption, index) of Object.keys(resourceTypeOptions)"
        :key="index"
      >
        <!-- Field Definition -->
        <CoscineFormGroup
          :label-for="resourceOption"
          :label="$t('page.settings.configuration.' + resourceOption + 'Label')"
        >
          <!-- Resource Size Field -->
          <b-form-input
            v-if="resourceOption === 'size'"
            :model-value="resourceSizeText"
            :readonly="readonly"
            :disabled="readonly"
          />

          <!-- Other Fields -->
          <b-button-group v-else class="w-100">
            <!-- Text Field -->
            <b-form-input
              class="rounded-end-0"
              :model-value="getPropertyValue(resourceOption)"
              :readonly="readonly"
              :disabled="readonly"
            />

            <!-- Copy Button -->
            <b-button
              :id="`copyButton${index}`"
              v-b-tooltip.click.top="
                $t('page.settings.configuration.toClipboard', {
                  resourceOption: $t(
                    'page.settings.configuration.' + resourceOption,
                  ),
                })
              "
              class="rounded-end-2"
              @click="copyText(getPropertyValue(resourceOption))"
            >
              <i-bi-clipboard />
            </b-button>
          </b-button-group>
        </CoscineFormGroup>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../../../store";
import type {
  QuotaDto,
  RdsOptionsDto,
  RdsS3OptionsDto,
  RdsS3WormOptionsDto,
  ResourceDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { CoscineResourceTypes, QuotaUnit } from "@/modules/resource/types";
import { FileUtil } from "@/modules/resource/utils/FileUtil";

export default defineComponent({
  components: {},
  setup() {
    const resourceStore = useResourceStore();

    return { resourceStore };
  },

  data() {
    return {
      coscineResourceTypes: CoscineResourceTypes,
      readonly: true,
    };
  },

  computed: {
    resource(): ResourceDto | null {
      return this.resourceStore.currentResource;
    },
    resourceSizeText(): string {
      const size = this.resourceTypeOptions[
        "size" as keyof typeof this.resourceTypeOptions
      ] as QuotaDto;
      if (size) {
        return this.$t("default.gb", { number: this.toGiB(size) }).toString();
      } else {
        return this.$t("default.none").toString();
      }
    },
    resourceTypeOptions():
      | object
      | RdsOptionsDto
      | RdsS3OptionsDto
      | RdsS3WormOptionsDto {
      if (
        this.resource?.type?.generalType ===
          this.coscineResourceTypes.Rds.General &&
        this.resource?.type?.options?.rds
      ) {
        return this.resource?.type?.options?.rds;
      } else if (
        this.resource?.type?.generalType ===
          this.coscineResourceTypes.RdsS3.General &&
        this.resource?.type?.options?.rdsS3
      ) {
        return this.resource?.type?.options?.rdsS3;
      } else if (
        this.resource?.type?.generalType ===
          this.coscineResourceTypes.RdsS3Worm.General &&
        this.resource?.type?.options?.rdsS3Worm
      ) {
        return this.resource?.type?.options?.rdsS3Worm;
      } else if (
        this.resource?.type?.generalType ===
          this.coscineResourceTypes.LinkedData.General &&
        this.resource?.type?.options?.linkedData
      ) {
        return this.resource?.type?.options?.linkedData;
      }

      return {};
    },
  },

  methods: {
    copyText(value: string | null | undefined) {
      if (value) {
        navigator.clipboard.writeText(value);
      }
    },
    getPropertyValue(
      resourceOptionProperty: string,
    ): string | null | undefined {
      if (
        Object.prototype.hasOwnProperty.call(
          this.resourceTypeOptions,
          resourceOptionProperty,
        )
      ) {
        return this.resourceTypeOptions[
          resourceOptionProperty as keyof typeof this.resourceTypeOptions
        ];
      }
    },

    /**
     * Converts a quota value to GiB (Gibibytes).
     * @param quota - The quota to be converted.
     * @returns {number} - The quota value in GiB.
     */
    toGiB(quota: QuotaDto | null | undefined): number {
      // Almost all displayed values inside the html must be shown in GiB, making this method necessary to ensure that's always the case.
      return quota
        ? FileUtil.convertCapacityUnits(quota, QuotaUnit.GibiByte)
        : 0;
    },
  },
});
</script>
